BaseSelector (Apache Ant API)
Date: 2018-07-10

org.apache.tools.ant.types.selectors

## Class BaseSelector

- java.lang.Object
- - org.apache.tools.ant.ProjectComponent
  - - org.apache.tools.ant.types.DataType
    - - org.apache.tools.ant.types.selectors.BaseSelector

- All Implemented Interfaces:
    java.lang.Cloneable, ResourceSelector, FileSelector
  Direct Known Subclasses:
    BaseExtendSelector, BaseSelectorContainer, ExtendSelector, MappingSelector, PresentSelector, ScriptSelector

      public abstract class BaseSelector
      extends DataType
      implements FileSelector

  A convenience base class that you can subclass Selectors from. It provides some helpful common behaviour. Note that there is no need for Selectors to inherit from this class, it is only necessary that they implement FileSelector.
  Since:
    1.5

- - ### Field Summary

    - ### Fields inherited from class org.apache.tools.ant.types.DataType

      `checked, ref`

    - ### Fields inherited from class org.apache.tools.ant.ProjectComponent

      `description, location, project`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseSelector()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected BaseSelector` | `getCheckedRef()` Performs the check for circular references and returns the referenced object.
    `java.lang.String` | `getError()` Returns any error messages that have been set.
    `abstract boolean` | `isSelected(java.io.File basedir, java.lang.String filename, java.io.File file)` Method that each selector will implement to create their selection behaviour.
    `void` | `setError(java.lang.String msg)` Allows all selectors to indicate a setup error.
    `void` | `setError(java.lang.String msg, java.lang.Throwable cause)` Allows all selectors to indicate a setup error.
    `void` | `validate()` Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.
    `void` | `verifySettings()` Subclasses can override this method to provide checking of their state.

    - ### Methods inherited from class org.apache.tools.ant.types.DataType

      `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes, toString`

    - ### Methods inherited from class org.apache.tools.ant.ProjectComponent

      `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tools.ant.types.selectors.FileSelector

      `isSelected`

- - ### Constructor Detail

    - #### BaseSelector

          public BaseSelector()

  - ### Method Detail

    - #### setError

          public void setError(java.lang.String msg)

      Allows all selectors to indicate a setup error. Note that only the first error message is recorded.
      Parameters:
        `msg` - The error message any BuildException should throw.

    - #### setError

          public void setError(java.lang.String msg,
                               java.lang.Throwable cause)

      Allows all selectors to indicate a setup error. Note that only the first error message is recorded.
      Parameters:
        `msg` - The error message any BuildException should throw.
        `cause` - Throwable

    - #### getError

          public java.lang.String getError()

      Returns any error messages that have been set.
      Returns:
        the error condition

    - #### verifySettings

          public void verifySettings()

      Subclasses can override this method to provide checking of their state. So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).

      Implementations should check for incorrect settings and call setError() as necessary.

    - #### validate

          public void validate()

      Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    - #### isSelected

          public abstract boolean isSelected(java.io.File basedir,
                                             java.lang.String filename,
                                             java.io.File file)

      Method that each selector will implement to create their selection behaviour. If there is a problem with the setup of a selector, it can throw a BuildException to indicate the problem.
      Specified by:
        `isSelected` in interface `FileSelector`
      Parameters:
        `basedir` - A java.io.File object for the base directory
        `filename` - The name of the file to check
        `file` - A File object for this filename
      Returns:
        whether the file should be selected or not

    - #### getCheckedRef

          protected BaseSelector getCheckedRef()

      Description copied from class: `DataType`
      Performs the check for circular references and returns the referenced object.
      Overrides:
        `getCheckedRef` in class `DataType`
      Returns:
        the dereferenced object.